import 'package:http/http.dart' as http;

class GenericApiClient {
  final headers = {'Content-Type': 'application/json'};

  Future<http.Response> genericGet(String requestPath) {
    final url = Uri.parse(requestPath);
    return http.get(
      url,
      headers: headers,
    );
  }

  Future<http.Response> genericPost(String requestPath, String objectToPost) {
    final url = Uri.parse(requestPath);
    return http.post(
      url,
      headers: headers,
      body: objectToPost,
    );
  }

  Future<http.Response> genericDelete(String requestPath, String? objectToDelete) {
    final url = Uri.parse(requestPath);
    if (objectToDelete == null) {
      return http.delete(url);
    }
    return http.delete(
      url,
      headers: headers,
      body: objectToDelete,
    );
  }

}