import 'package:bar_tender_api_dart/bar_tender_api_dart.dart';
import 'package:json_annotation/json_annotation.dart';

part 'dispenser_unified.g.dart';

@JsonSerializable()
class DispenserUnified {

  Dispenser dispenserDto;
  Bar barDto;
  Customer? customerDto;
  @JsonKey(defaultValue: {})
  Map<int, DispenserIngredient> dispenserIngredientDtoMap;
  @JsonKey(defaultValue: {})
  Map<int, Ingredient> ingredientDtoMap;

  DispenserUnified({
    required this.dispenserDto,
    required this.barDto,
    required this.customerDto,
    required this.dispenserIngredientDtoMap,
    required this.ingredientDtoMap,
  });

  factory DispenserUnified.fromJson(Map<String, dynamic> json) => _$DispenserUnifiedFromJson(json);
  Map<String, dynamic> toJson() => _$DispenserUnifiedToJson(this);

  static DispenserUnified empty(){
    return DispenserUnified(
      dispenserDto: Dispenser.empty(),
      barDto: Bar.empty(),
      customerDto: Customer.empty(),
      dispenserIngredientDtoMap: {},
      ingredientDtoMap: {},
    );
  }

}