import 'dart:convert';
import 'package:bar_tender_api_dart/src/customerUnified/CustomerUnified.dart';
import 'package:bar_tender_api_dart/src/dispenser_unified/dispenser_unified_api_client.dart';
import 'package:bar_tender_api_dart/src/models/Model.dart';
import 'package:bar_tender_api_dart/src/paths.dart';

import 'dispenser_unified.dart';

class DispenserUnifiedModel extends Model<DispenserUnified> {

  int idDispenser;

  DispenserUnifiedModel({this.idDispenser = 0}):
        super(
          urlPath: _buildUrl(idDispenser),
          apiClient: DispenserUnifiedApiClient(),
          value: DispenserUnified.empty());

  static String _buildUrl(int idDispenser) {
    return "${UNIFIED_DISPENSER}dispenser_by_id?idDispenser=$idDispenser";
  }

  Future<void> updateUrl(int idDispenser) async {
    urlPath = _buildUrl(idDispenser);
  }

  @override
  String toJson(DispenserUnified element) => jsonEncode(element);

  @override
  DispenserUnified fromJson(dynamic json) => DispenserUnified.fromJson(json);

  @override
  bool isValueEmpty() => value.dispenserDto.id == 0;

  @override
  List toList() => value.dispenserIngredientDtoMap.values.toList();

  bool isInitialize () {
    return idDispenser != 0;
  }

}