import 'package:bar_tender_api_dart/bar_tender_api_dart.dart';

class MemeStringGenerator {

  static String _generateImageUrl(String baseURL, ChartItem chartItem, ChartItemUnifiedModel chartItemUnifiedModel) {
    int idDrink = chartItem.idDrink;
    int idCustomer = chartItemUnifiedModel.value.customer.id;
    DrinkOrderUnified chartItemUnified = chartItemUnifiedModel.value;
    ChartDrinkUnified drinkUnified = chartItemUnified.unifiedDrinkWithIngredientsDto[idDrink] ?? ChartDrinkUnified.empty();
    String drinkName = drinkUnified.unifiedDrink.drink.name;
    String drinkType = drinkUnified.unifiedDrink.drink.category;

    return getImagetUrl(baseURL, idDrink, drinkName, drinkType, idCustomer);
  }

  static String generateJPG(ChartItem chartItem, ChartItemUnifiedModel chartItemUnifiedModel) {
    return _generateImageUrl(MEME_CONTROLLER_JPG, chartItem, chartItemUnifiedModel);
  }

  static String generateGIF(ChartItem chartItem, ChartItemUnifiedModel chartItemUnifiedModel) {
    return _generateImageUrl(MEME_CONTROLLER_GIF, chartItem, chartItemUnifiedModel);
  }

  static String generateWEBP(ChartItem chartItem, ChartItemUnifiedModel chartItemUnifiedModel) {
    return _generateImageUrl(MEME_CONTROLLER_WEBP, chartItem, chartItemUnifiedModel);
  }

  static String getImagetUrl(String baseURL, int idDrink, String drinkName, String drinkType, int idCustomer) {
    return "$baseURL?idDrink=$idDrink&drinkType=$drinkType&drinkName=$drinkName&idCustomer=$idCustomer";
  }

}